# PetscAttachDebuggerErrorHandler

Error handler that attaches a debugger to a running process when an error is detected. This routine is useful for examining variables, etc.

### Synopsis

    #include "petsc.h"
    #include "petscsys.h"
    PetscErrorCode  PetscAttachDebuggerErrorHandler(int line,const char* fun,const char *file,const char* dir,int num,int p,const char* mess,void *ctx)

Not Collective

### Input Parameters

| line | - the line number of the error (indicated by __LINE__)
| fun | - function where error occured (indicated by __FUNCT__)
| file | - the file in which the error was detected (indicated by __FILE__)
| dir | - the directory of the file (indicated by __SDIR__)
| message | - an error text string, usually just printed to the screen
| number | - the generic error number
| p | - the specific error number
| ctx | - error handler context

### Options Database Keys

-on_error_attach_debugger [noxterm,dbx,xxgdb,xdb,xldb,gdb] [ -display name] - Activates debugger attachment

### Notes

By default the GNU debugger, gdb, is used. Alternatives are dbx and xxgdb,xldb (on IBM rs6000), xdb (on HP-UX).

Most users need not directly employ this routine and the other error handlers, but can instead use the simplified interface SETERR, which has the calling sequence

        SETERRQ(number,p,message)

### Notes for experienced users

Use PetscPushErrorHandler() to set the desired error handler. The currently available PETSc error handlers are

       PetscTraceBackErrorHandler()

       PetscAttachDebuggerErrorHandler()

       PetscAbortErrorHandler()

or you may write your own.

### See Also

PetscPushErrorHandler(), PetscTraceBackErrorHandler(),
PetscAbortErrorHandler()

Level:developer
Location: src/sys/error/adebug.c
Index of all Sys routines
Table of Contents for all manual pages
Index of all manual pages